<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 30/10/19
 * Time: 20.03
 */

namespace FiloBlu\Rma\Setup;
use Magento\Framework\Setup\UpgradeDataInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use FiloBlu\Rma\Helper\InstallHelper;
use Symfony\Component\Console\Output\ConsoleOutput as Output;
use Magento\Eav\Setup\EavSetupFactory;

class UpgradeData implements UpgradeDataInterface
{
    /**
     * @var Output
     */
    protected $output;

    /**
     * @var InstallHelper
     */
    protected $installHelper;


    /**
     * @var EavSetupFactory
     */
    protected $eavSetupFactory;

    /**
     * UpgradeData constructor.
     * @param Output $output
     * @param InstallHelper $installHelper
     * @param EavSetupFactory $eavSetupFactory
     */
    public function __construct(Output $output, InstallHelper $installHelper, EavSetupFactory $eavSetupFactory)
    {
        $this->output = $output;
        $this->installHelper = $installHelper;
        $this->eavSetupFactory = $eavSetupFactory;
    }

    /**
     * @param ModuleDataSetupInterface $setup
     * @param ModuleContextInterface $context
     */
    public function upgrade(ModuleDataSetupInterface $setup, ModuleContextInterface $context)
    {
        try
        {
            $eavSetup = $this->eavSetupFactory->create(['setup'=>$setup]);
            $this->installHelper->addNewOrderStatus();
            $this->installHelper->addNewReasonOption($eavSetup);
            $this->installHelper->addNewRmaItem($eavSetup);
            $this->installHelper->hideReasonOther($eavSetup);
        }
        catch (\Exception $e)
        {
            $this->output->writeln("Error while creating new order status : $e");
        }
    }
}